package com.mobvcasting.mhttpfileposter;

import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

import processing.core.PMIDlet;

public class MHTTPFilePoster 
{
	String url;
	String fileName;
	byte outputArray[];
	String fileVar;
	String[][] vars;

	int status = 0;
	String serverResponse;

	PMIDlet pMIDlet;

	public final static int NOT_STARTED = 0;
	public final static int STARTED = 1;
	public final static int COMPLETED = 2;
	public final static int ERROR = 3;

	public MHTTPFilePoster(PMIDlet parent, String _url, String _fileName,
			String _fileVar, byte _outputArray[]) {
		url = _url;
		fileName = _fileName;
		fileVar = _fileVar;
		outputArray = _outputArray;

		this.pMIDlet = parent;
	}

	public MHTTPFilePoster(PMIDlet parent, String _url, String _fileName,
			String _fileVar, byte _outputArray[], String[][] _vars) {
		this(parent,_url,_fileName,_fileVar,_outputArray);
		this.vars = _vars;
		this.pMIDlet = parent;
	}
	
	
	public void startUpload() {
		HTTPFilePosterThread poster = new HTTPFilePosterThread();
		Thread posterThread = new Thread(poster);
		posterThread.start();
	}

	public String getServerResponse() {
		return serverResponse;
	}

	public int getStatus() {
		return status;
	}

	class HTTPFilePosterThread implements Runnable {
		public void run() {
			status = STARTED;

			HttpConnection c = null;
			InputStream is = null;
			OutputStream os = null;

			try {
				c = (HttpConnection) Connector.open(url);
				c.setRequestMethod("POST");
				String boundary = "---------------------------7d43722015402c8";
				String boundaryMessage = "--" + boundary
						+ "\r\nContent-Disposition: form-data; " + "name=\""
						+ fileVar + "\"; filename=\"" + fileName
						+ "\"\r\nContent-Type: " + "video/3gpp\r\n\r\n";
				String endBoundary = "\r\n--" + boundary + "--\r\n";
				c.setRequestProperty("Content-Type",
						"multipart/form-data; boundary=" + boundary);
				c.setRequestProperty("User-Agent", "Mobvcasting File Poster");
				c.setRequestProperty("Connection", "close");

				// Perhaps as a String with Base64 or MIME encoding?

				StringBuffer message = new StringBuffer(boundaryMessage);
				message.append(new String(outputArray));
				for (int i = 0; i < vars.length; i++)
				{
					message.append("\r\n--" + boundary + "\r\n");
					message.append("Content-Disposition: form-data; name=\"" + vars[i][0] + "\"\r\n\r\n");
					message.append(vars[i][1]);
				}

				message.append(endBoundary);
				
				// c.setRequestProperty("Content-Length",
				// Integer.toString(message.length()));

				os = c.openOutputStream();
				os.write(message.toString().getBytes());

				// dos.flush();

				// Read HTTP response
				final int response = c.getResponseCode();
				if (response == 200) {
					status = COMPLETED;
				} else {
					status = ERROR;
				}

				is = c.openDataInputStream();
				boolean cont = true;
				int ch;
				while (cont)
					if ((ch = is.read()) != -1)
						serverResponse = serverResponse + (char) ch;
					else
						cont = false;
				is.close();
				os.close();

				c.close();

				serverResponse = serverResponse.substring(0, serverResponse
						.length() - 1);

				pMIDlet.libraryEvent(this, status, getServerResponse());
			} catch (Exception e) {
				status = ERROR;
				serverResponse = e.getMessage();

				pMIDlet.libraryEvent(this, status, getServerResponse());
			}
		}
	}
}
